package ch.brotzilla.performance;

import ch.brotzilla.performance.tests.PerfTest;
import ch.brotzilla.performance.tests.PerfTestJava2DBufferedImage;
import ch.brotzilla.performance.tests.PerfTestJava2DVolatileImage;
import ch.brotzilla.performance.tests.PerfTestJogl;
import ch.brotzilla.performance.util.Triangles;

public enum TestType {

    Java2DBufferedImage("java2d-buffered-image") {
        @Override
        public PerfTest createPerfTest(Triangles triangles, int thread) {
            return new PerfTestJava2DBufferedImage(triangles, thread);
        }
    },
    
    Java2DVolatileImage("java2d-volatile-image") {
        @Override
        public PerfTest createPerfTest(Triangles triangles, int thread) {
            return new PerfTestJava2DVolatileImage(triangles, thread);
        }
    },
    
    JoglFixedFunctions("jogl-fixed-functions") {
        @Override
        public PerfTest createPerfTest(Triangles triangles, int thread) {
            return new PerfTestJogl(triangles, thread);
        }
    };
    
    private final String name;
    
    private TestType(String name) {
        this.name = name;
    }
    
    public String getName() {
        return name;
    }
    
    public abstract PerfTest createPerfTest(Triangles triangles, int thread);
    
}