package ch.brotzilla.performance.util;

import java.awt.Color;
import java.awt.geom.Path2D;
import java.util.Random;

import ch.brotzilla.performance.StaticSettings;

public class Triangle {

    public final double ax, ay, bx, by, cx, cy;
    public final float r, g, b, a;
    
    private Color color;
    private Path2D shape;
    
    public Triangle(double ax, double ay, double bx, double by, double cx, double cy, float r, float g, float b, float a) {
        this.ax = ax;
        this.ay = ay;
        this.bx = bx;
        this.by = by;
        this.cx = cx;
        this.cy = cy;
        this.r = r;
        this.g = g;
        this.b = b;
        this.a = a;
    }
    
    public Triangle(Random rng) {
        ax = rng.nextDouble() * StaticSettings.Width;
        ay = rng.nextDouble() * StaticSettings.Height;
        bx = rng.nextDouble() * StaticSettings.Width;
        by = rng.nextDouble() * StaticSettings.Height;
        cx = rng.nextDouble() * StaticSettings.Width;
        cy = rng.nextDouble() * StaticSettings.Height;
        r = rng.nextFloat();
        g = rng.nextFloat();
        b = rng.nextFloat();
        if (StaticSettings.UseAlphaBlending)
            a = rng.nextFloat() * 0.6f + 0.3f;
        else
            // make sure to call Random.nextFloat(), 
            // otherwise the triangles look different if no alpha blending is used.
            a = rng.nextFloat() * 0.0f + 1.0f; 
    }
    
    public Color getColor() {
        if (color == null)
            color = new Color(r, g, b, a);
        return color;
    }
    
    public Path2D getShape() {
        if (shape == null) {
            shape = new Path2D.Double();
            shape.moveTo(ax, ay);
            shape.lineTo(bx, by);
            shape.lineTo(cx, cy);
            shape.closePath();
        }
        return shape;
    }
    
}
