package ch.brotzilla.performance.util;

import java.util.Random;

import ch.brotzilla.performance.StaticSettings;

public class Utils {

    private Utils() {}
    
    public static long computePixelSum(int[] pixelData) {
        long result = 0;
        for (final int pixel : pixelData) {
            result += computePixelSum(pixel);
        }
        return result;
    }
    
    public static long computePixelSum(int pixel) {
        final int c1 = (pixel >> 24) & 0x000000FF;
        final int c2 = (pixel >> 16) & 0x000000FF;
        final int c3 = (pixel >> 8) & 0x000000FF;
        final int c4 = pixel & 0x000000FF;
        return c1 + c2 + c3 + c4;
    }
    
    public static double computeTrianglesPerSec(double elapsedTimeInMS) {
        return 1000.0 / (elapsedTimeInMS / (StaticSettings.NumberOfIterations * StaticSettings.NumberOfTriangles));
    }

    public static Triangles createRandomTriangles() {
        final Random rng = (StaticSettings.Seed != null) ? new Random(StaticSettings.Seed.hashCode()) : new Random();
        return new Triangles(rng, StaticSettings.NumberOfTriangles);
    }
    
}
